//BIOS.c
//.\lcc -target=xr18CX "-Wa -D STACKLOC=0xEEEE" "-Wa -D NOFILLBSS=1 " "-Wa -D DATALOC=0xC000" "-Wa -D CPUSPEED=5000000" BIOS.c -o BIOS.hex "-Wf -volatile -cpu1805" "-DSCC=2" "-DDEBUG=0"
//set "-DSCC=1" to "-DSCC=0" to set it to bitbang Serial
//DATALOC moved from 0x8000 to 0xC000 to have 16K of ram free for bootloading
//stack went from 0xFFFF to EEEE to allow BIOS (reserved memory) bytes
//we have as such 12 014Bytes of free memory
#include <nstdlib.h>
#include "olduino.h"
#include <rand.h>



//#include <errno.h>
//#include <stdint.h>
void sccDEFAULT();
#include "SPI.h"
#define NULL 0x00
//#include <dumper.c>

#include <1806.h>
#include <EF.h>
#ifndef ULONG_MAX
#define	ULONG_MAX	((unsigned long)(~0L))		
#endif

#define ERANGE ((unsigned long)(~0L))

#if(SCC == 0)
#define putc(x) putcser(x)
unsigned char getcser();
#define getc() getcser()
void putcser(unsigned char);

#endif


#if(SCC == 2)

#include "scc.h"
#define putc(x) sccOUT(x);
#define getc() sccIN()
void sccOUT(char);
char sccIN();

#endif


#if(DEBUG == 1)
#error DEBUG MODE IS ON
#endif
//#define EOT 4
//#define REGADDR (unsigned int *)0xFF00 //where the registers are stored on reset
//#define CODEADDR (unsigned char *)0x8000 //address where code is loaded
//const int maxInputLength = 200; //max ammount of data you can send in one line
//const int maxFileSize = 8192; //max of 8Kbytes per file size
char getINint();
void printShape(int color, int x, int y, int length, int height);
void calculator(char* varA, char* varB,char* operation);
void inputprompt(char* cin,char* cin2);
void outputprompt(char* cin,char* cin2,int buffer);
void infodisplay();
void hexdumper(int start,int end);
void hexdump(unsigned char *start, int span);
void mem_view(unsigned int* startAddress, int length);
void printsn(float k);
void floatToScientific(float num);
void mem_view(unsigned int* startAddress, int length);
unsigned long int checksum(char *data,unsigned int size);
long double expression(char* string, char** lastPosition);
void IntToScientific(int num);
void UIntToScientific(unsigned int num);
void switchbank(char banknumber);
void ADCPRINTVALUE(int channel,char relay);
void RTCPOKE();
void BIOSMENU();
unsigned char write_data(unsigned long int address,unsigned char *data,unsigned int size);
char*   getsSized(char *s,unsigned int size);

//used for IO, to set or reset a bit, you XOR the bit you want to set with the reg and then output the reg
//its safer, so it doesnt interfear with other bits
/* global vars breaking things again
//char OREG1;
//char IOREG2A;
//char IOREG2B;
char IOREG2C;

char IOREG3A;
char IOREG3B;
char IOREG3C;

char IOREG4A;
char IOREG4B;
char IOREG4C;

char IOREG5A;
char IOREG5B;
char IOREG5C;
*/
//long int tester;
//long int tester;

double ANS; //value for ans
char gpiocount;
int usermem;
char *gets(char *);
void Sky();
//char memorydisplay; //to enable or disable the memory viewer
//	char  EF1func=(char )0xfff0;
//	char  EF2func=(char )0xfff1;
//	char  EF3func=(char )0xfff2;
//	char  EF4func=(char )0xfff3;
//	char  ADCIO=(char )0xfff4;
//	char  baudrate=(char )0xfff5;
	int progmemorysize;


unsigned int atoui(register char* inputString)
{
    unsigned int numResult = 0;
    while(*inputString >= '0' && *inputString <= '9') {
        numResult *= 10;
        numResult += *inputString - 48;
        inputString++;
    }

    return numResult;
}


int randomizer(int min, int max)
{
    int range = max - min;
    return min + rand(rand(rand(rand()))) % range;
}

/*
@return A shared pointer to a random MOTD
*/
void randomMOTD(char *buffer)
{
    const char error[] = "se estás a ler isto, o código falhou\n";
    const char *arr[] = {
        "Sabias que o 11-ETC é o melhor?\n",
        "Marta fez isto originalmente como uma piada, mas acabou por vender duas cópia desta unidade!\n",
       // "Estas mensagens aleatórias ocupam um pouco de espaço.\n",
       // "Há muitas funções escondidas!!\n",
       // "Isto é um exemplo de um sistema operativo.\n",
      //  "Operacional e pronto para controle.\n",
       // "Tenta alimentar isto com batatas!\n",
        "As primeiras versões do SBC1806 era o SBC1802 e tinha apenas 2Kbytes de ROM e 256Bytes de RAM.\n",
       // "Este programa cabe em 27Kbytes e usa pouca RAM.\n",
        "Se o teu terminal suportar, há texto colorido, permitindo criar imagens!\n",
        //"Não consomas mais do que 1A no SBC1806, se não o regulador ficara instavel!\n",
        "Já tentaste desligar e voltar a ligar?\n",
        //"MTxunil\n",
        "Usa 'clear' para limpar o ecra!\n",
       // "Não é um microcontrolador! É um microprocessador, e não é um arduino tambem..\n",
       // "O processador pode operar desde 0Hz ate 4Mhz, mas aqui pode funcionar so desde 1Mhz ate 4Mhz.\n",
        //"Marta anda a fazer uma versão de 32-bit e 64-bit do CDP1806.\n",
       // "Sem FPGAs!\n",
       // "WAIT pausa o processador. Achei que achasses isso interessante.\n",
       // "CLEAR reseta o processador mas não os outros ICs.\n",
        //"932 ilhas, 481 vias, 6264 segmentos de pistas e 287 redes, que confusão!!\n",
       // "Isto não deveria aparecer...\n",
        //"Tenta transferir mais RAM!\n",
       // "Tudo é uma máquina de fumo se usada de forma errada o suficiente.\n",
       // "Usa a lingua C!!\n",
        //"RS232 incluido!\n",
        //"https://www.pingodoce.pt/receitas/coleccoes/receitas-de-bolos/\n",
       // "https://www.youtube.com/watch?v=dQw4w9WgXcQ\n",
        //"Para acessar IO, usa os comandos 'output' e 'input'.\n",
        "Para mais textos como estes, usa 'motd'.\n",
       // "Possivelmente funcional!\n",
       // "Putty tem melhor experiencia de uso, mas realTerm tem a capacidade de carregar códigos.\n",
       // "Na expocolgaia 2023, Marta não fez uma demonstração prática pois o SBC1802 tinha sido danificado por ESD e partes como o socket da ROM serem SMD e muito pequenos.\n",
       // "Usando comandos para controlar o timer/contador do CPU, é possivel calcular a velocidade do CPU mas tambem fazer multi tasking.\n",
		"Se backspace não funciona, usa ctrl+H\n",
       // "ENQ é uma sequencia enviada para saber qual é o terminal a ser utilizado no momento.\n",
       // "Se fosse possivel serializar os bytes de imagens e enviar, o código seria mais rápido.\n"
        
    };


    int number = randomizer(0, sizeof(arr) / sizeof(char *));

    const char *output = NULL;
    if (number >= 0 && number < sizeof(arr) / sizeof(char *)) {
        output = arr[number];
    } else {
        output = error;
    }

    strcpy(buffer, output);
}

char *
strtok(s, delim)
char *s;
const char *delim;
{
    char *spanp;
    int c, sc;
    char *tok;
    static char *last;


    if (s == 0x00 && (s = last) == 0x00) {
        return (0x00);
    }

    /*
     * Skip (span) leading delimiters (s += strspn(s, delim), sort of).
     */
cont:
    c = *s++;
    for (spanp = (char *)delim; (sc = *spanp++) != 0;) {
        if (c == sc) {
            goto cont;
        }
    }

    if (c == 0) {		/* no non-delimiter characters */
        last = 0x00;
        return (0x00);
    }
    tok = s - 1;

    /*
     * Scan token (scan for delimiters: s += strcspn(s, delim), sort of).
     * Note that delim must have one NUL; we stop if we see that, too.
     */
    for (;;) {
        c = *s++;
        spanp = (char *)delim;
        do {
            if ((sc = *spanp++) == c) {
                if (c == 0) {
                    s = 0x00;
                } else {
                    s[-1] = 0;
                }
                last = s;
                return (tok);
            }
        } while (sc != 0);
    }
    /* NOTREACHED */
}


void main()
{
	//int registerD=0;
	//int seconds=0;
	//int minutes=0;
	//int hours=0;
	
	char *test;
    char buffer[32]; //now replaced with TTYINPUT[512]
	char junkbuffer[4096];//small buffer for functions that may need one
	
    char motdmessage[256];
    int randomNumber = rand(rand());
    char str[20]; // declaring a character array
    char cin[4];
    char cin2[4];
	//int SPICOMMAND = 0x00;
	//int SPIBYTE = 0x00;
	//char LOADmem[16384];
	char *progmemory = (char*)0x8000;
    char *token;
    int i = 0;
	//int *malloctest;
    char command[64], var1[64], var2[64], var3[64], var4[64];
    char * flag=(char *)0xfff0; //point to a piece of ram
	int * externalprogramid=(int *)0xffe0; //point to this address, this has the ID of the code to run on the other banks
	char * bankbootindication=(char *)0xffe1; //point to this address, this has the boot/bank return, when its the first boot data is random, but from bank return, its 0x32
    
	int rgbloop=0;
    char *commandpt = command;
    char *var1pt = var1;
    char *var2pt = var2;
    char *var3pt = var3;
    char *var4pt = var4;
	int outputbuffer = 0;
	long double expressionresultholder = 0;
    gpiocount = 1; //because of SCC2692
//    memorydisplay = 0; //so it shuts up
    *flag=0; //set flag to 0 //
	*externalprogramid=0;//0 is BIOS ID
	
	/*
	for(i=0;i<sizeof(TTYINPUT);i++){
		TTYINPUT[i]=0x00;//clear buffer on reboot
	}
	TTYINPUTCOUNT=0; //we shouldnt have any chars there yet */
	//fault here
    asm("	req\n"); //turn Q off
	asm("	seq\n");
    asm("	ldAD R1,_INTHANDLER  ;.. R1 = INTERRUPT PC\n"); //set R1 to point to the interrupt routine
	//asm("	ldAD R1,_INT2  ;.. R1 = INTERRUPT PC\n");//set R1(interrupt counter) to execute our subroutine
	out(1,0x03);
    out(2,0x80); //10010001 //so port C bits 0-3 are inputs for setting or quiting code
	out(4,0x80); //IO 4 is now having its port A as bidirectional <-> 1100 0000 0xC0
    out(3,0x80);
    out(1,0x00);
	
	//out(1,0x01);
	//out(4,0xFF);//init this for parallel bus
 #if(SCC == 1 || SCC == 2)
    //printf("Starting IO....\n");
	


	
	
	//out(ADCIO,0x91);//override to make it accept the ADC
	
	
    asm("	seq\n"); //turn Q on

    out(1,0x01);//select port b
	//controlWrite(0x01);
    out(4,0x02); //CRA
    out(6,0x10); // 00010000 set pointer to MR1A

    out(4,0x00); //adress 00 //MR1A//MR2A
    out(6,0x53); //0101 0011 decimal 83 hex 0x53
    out(6,0x07); //00 0 0 0111 //normal,no rts control,no cts control, 1 stop bit decimal
	
	
	//this has been serialized
	

    out(4,0x02); //CRA
    out(6,0x05); // 0000 0101


	
	
    out(4,0x01); //csra
    out(6,0xBB); //0100 0100 300 bound but in test mode wich is the one we use, its 28.8Kboundrate       //9600 bound rate is 1011 1011 we use 9600 for now 18/11/2023
	//out(6,0x66);    //0110 0110 1200 baud but when in BRG test it gives us 115200baudrate
	//out(6,0xCC); //1100 1100 19200 baud ACR[7]=1 // ACR[7]=0 then 38.4K
	
	//out(4,0x04);
	//out(6,0x80); //set ACR[7]=1, set to 0x00 for ACR[7]=0
	
    out(4,0x05); //R5 :: IMR interrupt mask register
    out(6,0x02);//0000 0010 //for when only Rx of channel A is ready

    out(4,0x02); //CRA
    out(6,0x05); // 0000 0101
	

	
    inp(6); //read register two wich changes to BRGTEST, to make it from 300 bound to 28.8Kboundrate
	
	out(4,0x04);
	out(6,0x80); //set ACR[7]=1, set to 0x00 for ACR[7]=0
	
	
    delay(1000);
    asm("	req\n"); //turn Q on
	
	printf("canal 1 ligado\n");
	out(1,0x01);//select port b
	//controlWrite(0x01);
	out(4,0x0A); //CRB
    out(6,0x10); // 00010000 set pointer to MR1A
	out(4,0x08); //adress 08 //MR1b//MR2b
    out(6,0x53); //010 10 0 11 decimal 83 hex 0x53
    out(6,0x07); //00 0 0 0111 //normal,no rts control,no cts control, 1 stop bit decimal
	
	out(4,0x0A); //CRB
    out(6,0x05); // 0000 0101
	out(4,0x09); //csrb
    out(6,0xBB); //0100 0100 300 bound but in test mode wich is the one we use, its 28.8Kboundrate       //9600 bound rate is 1011 1011 so BB
	out(4,0x0A); //CRB
    out(6,0x05); // 0000 0101
	
	
	
	printf("canal 2 ligado\n");
	
	out(4,0x04); //Aux. Control Register (ACR)
	out(6,0x60);//0110 0000
	
	out(4,0x00); //C/T Upper Preset Value (CRUR)
	out(6,0x01);
	out(4,0xFF); //C/T Lower Preset Value (CTLR)
	out(6,0x0A);
	out(4,0x01); //Start Counter Command
	inp(6);
	out(4,0x0D); //Output Port Conf. Register (OPCR)
	out(6,0x04); //C/T OUTPUT
	
#endif 

    printf("\033[2J");
    printf("\033[H"); //move cursor to home position, 0,0, so the top of the display
    printf("\x1b[0m");

	
	out(1,0x01);
	
    printf("Olá Marta\n");
    printf("Usa 'help' para lista de comandos\n");
    printf("Sem erros por enquanto\n");
    printf("[39;49m \n");
    randomMOTD(motdmessage);
    printf(motdmessage); //random MOTD



        programbreak: //for programs that support pressing x to force them to stop
		asm("postboot:\n");//flag used in the returnerfrombanks tool
		asm("	req\n");
	    while(1){
        printf("Ready!\n");
        printf(">");
#if(SCC==2)
	   gets_asm(buffer);
#endif

#if(SCC==0)
	   gets(buffer);
#endif

	   printf("\n");
		asm("pastgets:\n");//used so after interrupts from this
		 asm("	ldAD R1,_INTHANDLER  ;.. R1 = INTERRUPT PC\n"); //set R1 to point to the interrupt routine
        token = strtok(buffer, " ");//changed from buffer to TTYINPUT
        strcpy(command, token);
        memset(var1,0,sizeof(var1)); //clear out this buffers
        memset(var2,0,sizeof(var2));
        memset(var3,0,sizeof(var3));
        memset(var4,0,sizeof(var4));  ////we should optimize this
        for (i = 0; i < 4; i++) {
            token = strtok(NULL, " ");
            if (token != NULL) {
                switch (i) {
                case 0:
                    strcpy(var1, token);
                    break;
                case 1:
                    strcpy(var2, token);
                    break;
                case 2:
                    strcpy(var3, token);
                    break;
                case 3:
                    strcpy(var4, token);
                    break;
                case 4:
                    break;//if too many arguments are sent, kill them
                }
            } else {
                //  printf("Error: Insufficient input\n");
                // return 1;
            }
        }//end of it
        if(strcmp(command,"help")==0) {
			//case 'h':
			//printf("%c\n",cin);
			printf("\n");
			printf("help:\n basic:\n");
			printf("input <IO chip> <Port>: reads IO ports\n");
			printf("output <IO chip> <Port> <Value>: Acess to IO outputs\n");
			printf("random <opt1: min> <opt2: max>: randomize the random value\n");
			printf("about: credits and such\n");
			printf("clear: wipes screen\n");
			printf("info: returns information about the SBC1806 state\n");
			printf("motd: mensagem aleatória\n");
			printf("BIOS: acessa as definições da BIOS\n");
			printf("fract:  descobre :)\n");
		}else if(strcmp(command,"fract")==0) {
			//case 'r':
	
			// printf("\033[2J");
			//printf("\033[H"); //move cursor to home position, 0,0, so the top of the display
			//break;
				
				mandelbrot();
				
        } else if(strcmp(command,"test")==0) {
            //timer logic//
            /*
            5 000 000 hz / 8(n of clocks pulses per cycle)  = 625000
            625000/32(divider of counter in STC mode)= 19531.25 (19.5Khz+~-)

            19531.25/ x(x for 1-255)= number of interrupt a second
            so preset to 255 gives 76.5931372549  interrupts a second
            so a interrupt every 0.013056seconds
            */
            asm("_STMLOOP:\n");
            asm(
                "   XIE\n"
                "   CIE\n"
                "   LDI 0xFF\n"
                "   LDC\n"
            );
            asm("   SCM1\n");
            asm("_waitcnt:\n"); //await for the counter to reach 00
            asm("   BCI _exitwaitcnt\n");//await for the counter interrupt flag to be set
            asm("   BR _waitcnt\n");
            asm("_exitwaitcnt:\n");
            asm("   RLDI R1,_STM_HANDLER\n");
            asm("   LBR _STMLOOP\n");


		} else if(strcmp(command,"time")==0) {

            out(1,0x01);
            out(4,0x0E);
            out(7,0x06);
            rtc_check();

        } else if(strcmp(command,"settime")==0) {
            printf("format: hh:mm:ss\n");
            RTC_settime(atoi(var1),atoi(var2),atoi(var3));
			
		} else if(strcmp(command,"LOAD")==0) {
				
				if(atoi(var1)<=0){
					printf("Error: allocation must be larger than 0 and less or equal to 8192.\n");
					
				}else{
					//printf("75ms between chars required.(100ms for better results)\n");
					//getsSized(progmemory,atoi(var1));
					

                    #if(SCC==2)
                        
	                 getsSized_asm(progmemory,atoui(var1));
                    #endif

                    #if(SCC==0)
                     printf("A 100ms char delay is needed.\n");
	                 getsSized(progmemory,atoui(var1));
                    #endif
					//test =  (char*)malloc(atoi(var1));
					//if(test){
					//getsSized(test,atoi(var1));
					printf("Código carregado");
					//printf("Recebidos: %d bytes\n",atoi(var1));
					printf("Checksum: 0x%lx\n",checksum(progmemory,atoui(var1)));
					progmemorysize=atoui(var1);
					
				}
	
				
				
			} else if(strcmp(command,"READ")==0) {
				if(atoi(var1)<=0){
					printf("Error: you must read one or more bytes (1-8192)\n");
				}else{
					
					for(i=0;i<atoi(var1);i++){
						printf("%cx,",progmemory[i]);
					}
					printf("Pronto\n");
					printf("tamanho: %d bytes\n",progmemorysize);
					printf("Checksum: %lx\n",checksum(progmemory,progmemorysize));
					
				}
				
			} else if(strcmp(command,"RUN")==0) {
				//if(progmemorysize<=0){
				//	printf("Error: code size is 0 Bytes, you need to load the code first by using: 'LOAD <size>'\n");
				//}else{
					
				printf("executando %d bytes....\n",progmemorysize);
				
				asm("	lbr 0x8000\n");//execute the code in ram
				//}
				
			} else if(strcmp(command,"ERASE")==0) {
				
				printf("Erasing %d Bytes\n",progmemorysize);
				for(i=0;i<progmemorysize;i++){
					progmemory[i]=0xFF;//hard wipe
				}
				//free((unsigned char *)test);
				printf("Done\n");
				progmemorysize=0;
				
	
		} else if(strcmp(command,"info")==0) {
	
			infodisplay();
	
	
	
		}else if(strcmp(command,"motd")==0) {
	
			randomMOTD(motdmessage);
			printf(motdmessage); //random MOTD
		}else if(strcmp(command,"about")==0) {
			
	
			printf("\033[48;2;252;0;223m            \033[m\n");
	
			printf("\033[48;2;0;252;240m            \033[m\n");
	
			printf("\033[48;2;255;255;255m            \033[m\n");
			//printf("");
			printf("\033[48;2;0;252;240m            \033[m\n");
			//printf("");
			printf("\033[48;2;252;0;223m            \033[m\n");
			//printf("");
			printf("\033[0m");
			///////////
			printf("Made by: MsAlPatina!\n");
			printf("Major thanks to: Bill, Grisses, nicky_5 and Zled!\n");
			printf("https://github.com/MsAlPatina\nhttps://github.com/Grissess\nhttps://github.com/bill2009\nhttps://github.com/zledtriac\nhttps://github.com/nicky-5\nhttps://github.com/MsAlPatina/SBC1806\n");
			
			
	
			//printf("\033[48;5;194m");
			//printf("  \n");
			printf("\033[0m");
		}
	
	
	
		else if(strcmp(command,"rgb")==0) {

            
	
			if(atoi(var1) <= 0) {
				printf("Erro: arg1 deve ser maior que 0 (define o numero de ciclos).\n");
	
			} else {
				if(atoi(var2)<=0) {
					printf("Aviso: arg2 nulo defenido valor para 250ms.\n");
					strcpy(var2,"250");
				} else {
					printf("Party time!\n");
				}
	
				printf("\033[41m            \033[m\n");
				//printf("            \n");
				printf("\033[43m            \033[m\n");
				//printf("            \n");
				printf("\033[42m            \033[m\n");
				//printf("            \n");
				printf("\033[44m            \033[m\n");
				//printf("            \n");
				printf("\033[45m            \033[m\n");
				//printf("            \n");
	
				printf("\033[32;49m");
				printf("Embrace the rainbow!! \n");
				printf("Press c to stop\n");
	
				printf("\033[0m");
	
				//printf("%c",0x13); //so no sending stuff
				//while(getINint()){
					//out(1,0x01); //port B
				for(rgbloop=0; rgbloop<=atoi(var1)||!(inp(6) & 0x01); rgbloop++) {
					//printf("%c\n",cin);
						//out(1,0x01); //port B
					randomNumber = randomizer(1, 7); //cap it to 7
						randomNumber |= randomizer(16,240);
					//printf("random number = %d\n",randomNumber);
					out(1,0x00);
					out(4,randomNumber);
					delay(atoi(var2));
						out(1,0x01); //port B
						
						if(inp(6) & 0x01){
						
						out(1,0x01); //port B
						out(4,0x03); //select RXHA
						//buffer = inp(6);
							if(inp(6) == 'c'){
							asm("	lbr rgbbreaker\n");
							}
						}
				}
					asm("rgbbreaker\n");
				//}
					
				//printf("%c",0x11); //now you can send stuff
			}
		} else if(strcmp(command,"input")==0) {
			inputprompt(var1,var2);
		} else if(strcmp(command,"output")==0) {
					var3pt = var3;
					outputbuffer = (int)expression(var3pt,&var3pt);
			if(outputbuffer < 0 || outputbuffer > 255) {
				printf("Value to output goes from 0 to 255\n");
			}else if(strcmp(var3,"ans")==0){
					outputprompt(var1,var2,(int)ANS);
				} else {
					//printf()
					//var3pt = var3;
				outputprompt(var1,var2,outputbuffer);
			}
				
				
		} else if(strcmp(command,"sleep")==0) {	
			sleepMODE(atoi(var1),atoi(var2));
		} else if(strcmp(command,"random")==0) {
			//case 'r':
			//printf("%c\n",cin);
	
			if(atoi(var2) > atoi(var1)) {
				printf("%d\n",randomizer(atoi(var1), atoi(var2)));
			}
	
			printf("Rand used to be: %d\n",randomNumber);
			randomNumber = rand(rand());
			printf("Now rand is: %d\n",randomNumber);
			//break;
		} else if(strcmp(command,"clear")==0) {
			//case 'r':
	
			printf("\033[2J");
			printf("\033[H"); //move cursor to home position, 0,0, so the top of the display
			//break;
		}
	
		else if(strcmp(command,"beep")==0) {
			//case 'b':
			//printf("%c\n",cin);
			if(var1 == 0x00) {
				printf("Error on: arg1, expected value, got NULL.\n");
				printf("beep <beep time in ms.\n>");
			} else if(var1 != 0x00) {
					
					if(atoi(var2)==0){
						printf("Warning, no frequency, defaulting to 1Khz\n");
						
					}else{
	
						if(strcmp(var1,"ans")==0) { //take the value ANS of a previusly calculated value
							out(1,0x80);
							delay((int)ANS);
							out(1,0x00);
						} else {
							var1pt = var1;
							expressionresultholder = expression(var1pt,&var1pt);
								if((int)expressionresultholder <= 0) {
									printf("Error on: arg1, value cant be less or equal to 0.\n");
								//return 0x00;
								} else {
	
						// var1pt = var1;
						//ANS = expression(commandpt,&commandpt);
								for(i=0;i<1000*atoi(var1);i++){//so the frequency*the time in mseconds
									//so 500 would do a delay of 2ms (1000/500)
									out(1,0x80);
									delay(1);
									out(1,0x00);
									delay(1);
								}
							}
						}
				}
				//break;
			}
		}else if(strcmp(command,"shutdown")==0) {
			//case 's':
			printf("%c\n",cin);
			printf("\a"); //plays a sound on the terminal
			printf("Shutting down\n");
			//delay(2000);
			printf("\a"); //plays a sound on the terminal
			// out(1,0x00); //shut down all pins
			printf("Bye!\n");
			//asm("idl\n"); //we halt the CPU
			//exit(0); prints exit, then the value given, then goes in a while loop
			while(1) {
				asm("	req\n");
				delay(250);
				asm("	seq\n");
				delay(250);
			}
				
				
			}else if(strcmp(command,"reboot")==0){
				
				asm("	IDL\n");//idling will cause S0 to stop, triggering the watchdog timout and reboot the system
				
		
		} else {
	
			//calculator(command,var2,var1);
			commandpt = command;
			ANS = expression(commandpt,&commandpt);
				
				
				if(ANS==0){
					printf("%f\n",ANS);
				}else{
				
					if(ANS < 1000 & ANS >= 0.001) {
						printf("%f\n",ANS); //in this case, we pass the expression, it must be 2-34-54, not 2 - 34 - 54
					}
					if(ANS > 1000) {
						floatToScientific(ANS);
						printf("\n");
					}
					if(ANS < 0.001) {
						floatToScientific(ANS);
						printf("\n");
			
					}
				}
			//printf("command not recognised.\n");
			//printf("\a"); //plays a sound on the terminal
	
			
	
		}

	}
}


#if(SCC==0)
char*   getsSized(char *s,unsigned int size)//changes for speed
{
	
	unsigned int received=0;
	//int memoryreceivedbytes = 0;
    char ch,*p;
	progmemorysize=0;
    //usermem = 0;
    p=s;
//	
	asm("	seq\n");
    while (received < size) { //replaced \n with 
        //printf("%c",0x13); //send DC3, so XOFF, stop TX decimal 19
			ch = getc();
            *s++ = ch;
            usermem++; //increment the memory pointer
			received++;
			
			progmemorysize++;
			//printf("%l\n",sized);
			//printf("got:%x\n",ch);
			//printf("user memory:%d\n",usermem);
			//printf("got:%d\n",memoryreceivedbytes);
        }
       // printf("%c",ch);
        //printf("%c",0x11); //send DC1, so XON , allow TX decimal 17
    
   // printf("\n"); //this is so upon enter, it avoids things like 222You entered
    *s='\0';
	asm("	req\n");
    return p; //return the address of S stored in P.
}


char*   gets(char *s)
{

    char ch,*p;
    usermem = 0;
    p=s;
    while ( (ch=getc()) != '\r') { //replaced \n with 
	
        putc(0x13); //send DC3, so XOFF, stop TX decimal 19
        if(ch == 0x08) { //\b is used but i go with 0x08
            *s = '\0';
		  // *s--;
            if(s > p) {
                s--;    //added backspace compatability , so no more pressing enter to undo your error
            }
        } else {
            *s++ = ch;
            usermem++; //increment the memory pointer
        }
        printf("%c",ch);
        putc(0x11); //send DC1, so XON , allow TX decimal 17
    }
    printf("\n"); //this is so upon enter, it avoids things like 222You entered
    *s='\0';
	//TTYINPUTCOUNT=0;//added this so when read the stack it clears it
    return p; //return the address of S stored in P.
}

#endif

void STM_HANDLER(){

    asm(
        "   SAV\n"
        "   XID\n"
        "   CID\n"
        //"   STPC\n"
        "   RET\n"

    );



}




void outputprompt(char* cin,char* cin2,int buffer)
{
    if(strcmp(cin2,"a")==0) {
        out(1,0x00);
    } else if(strcmp(cin2,"b")==0) {

        //case 'b':
        out(1,0x01);
    } else if(strcmp(cin2,"c")==0) {

        //case 'c':
        out(1,0x02);
    } else if(strcmp(cin2,"ctrl")==0) {
        out(1,0x03);

    } else {
        //default:
        printf("only a,b,c or ctrl\n");
        //break;
    }

    if(atoi(cin)>=1 ||atoi(cin)<=7) {
        out((char)atoi(cin),buffer);
        //break;
      //break;
    } else {
        //default:
        printf("invalid io it goes from 1-7 \n");
        //break;
    }


    printf("Done\n");


}


void inputprompt(char* cin,char* cin2)
{

   
    if(strcmp(cin2,"a")==0) {
        out(1,0x00);
    } else if(strcmp(cin2,"b")==0) {

        //case 'b':
        out(1,0x01);
    } else if(strcmp(cin2,"c")==0) {

        //case 'c':
        out(1,0x02);
    } else if(strcmp(cin2,"ctrl")==0) {

        out(1,0x03);
    } else {
        //default:
        printf("only a,b,c or ctrl \n");
        //break;
    }

    if(atoi(cin)>=2 || atoi(cin) <=7) {
        //printf("%c\n",cin);
        printf("Readed: %x \n",inp((char)atoi(cin)));
        //break;
    
        //break;
    } else {

        //default:
        //printf("%c\n",cin);
        printf("IO Not Recognized, it goes from 2-7\n");
        //break;


        //internal i

        //for i
        //break;
    }

}



void infodisplay()
{
    char * flag=(char *)0xfff0;
    char buffer[12];
    printf("SBC1806 INFO\n");
    //memdisplay();
    printf("ROM: 128Kbytes Versão:8.4 18/08/2024\n");
    printf("RAM:128Kb/256Kb\n");


    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    printf("\n");
    printf("\033[48;2;37;155;36m User memory.\033[m\n");
    printf("Used: %dB/26kb\n",usermem);
	printf("\033[48;2;0;188;212m Program memory.\033[m\n");
	printf("Used %dB/16Kb\n",progmemorysize);
    printf("IO:\n");
    printf("	%d/4 GPIO 82C55\n",gpiocount);
    printf("	1/1 DUART SCC2692\n");
   // printf("	2/2 MAX232\n");
   // printf("	0/1 RTC CDP6818/BQ4845\n");
   // printf("ADC IO:%d\n",ADCIO);
    printf("CPU:");
    printf("	CLOCK:5Mhz\n");
    printf("	Tipo:1806\n");
    printf("SCC2692\n");
    printf("	CLOCK:3.6864Mhz\n");
    printf("	Baund rate: 9600\n");
    printf("	Max character speed: 960(CPS)\n");
    printf("\n");

}


void floatToScientific(float num)
{
    int exponent = 0;

    while (num >= 10.0 || num <= -10.0) {
        num /= 10.0;
        exponent++;
    }

    while (num < 1.0 && num > -1.0) {
        num *= 10.0;
        exponent--;
    }

    printf("%f x 10^", num);
    printf("%d", exponent);
}





//ALPHA
long double expression(char* string, char** lastPosition);

long double atofinternal(char *s, char** lastPosition)
#define isdigit(c) (c >= '0' && c <= '9')
{
    // This function stolen from either Rolf Neugebauer or Andrew Tolmach.
    // Probably Rolf.
    long double a = 0.0;
    int e = 0;
    int c;
    while ((c = *s++) != '\0' && isdigit(c))
    {
        a = a*10.0 + (c - '0');
    }
    if (c == '.')
    {
        while ((c = *s++) != '\0' && isdigit(c)) {
            a = a*10.0 + (c - '0');
            e = e-1;
        }
    }
    if (c == 'e' || c == 'E')
    {
        int sign = 1;
        int i = 0;
        c = *s++;
        if (c == '+') {
            c = *s++;
        } else if (c == '-') {
            c = *s++;
            sign = -1;
        }
        while (isdigit(c)) {
            i = i*10 + (c - '0');
            c = *s++;
        }
        e += i*sign;
    }
    while (e > 0)
    {
        a *= 10.0;
        e--;
    }
    while (e < 0)
    {
        a *= 0.1;
        e++;
    }

    *lastPosition = s - 1;
    return a;
}


long double factor(char* string, char** lastPosition)
{
    long double result;
    if(*string == '(') {
        string++;
        while(*string == ' ') {
            string++;    //skip spaces;
        }
        while(*string != ')' && *string != 0) {
            result = expression(string, &string);
        }
        string++;  // eat the )
    } else {
        result = atofinternal(string, &string);
    }

    *lastPosition = string;

    return result;
}


long double term(char* string, char** lastPosition)
{
    long double numResult = 0;
    long double result = 0;

    while(*string == ' ') {
        string++;    //skip spaces;
    }

    result = factor(string, &string);

    while(*string != 0) {


        while(*string == ' ') {
            string++;    //skip spaces;
        }

        if(*string == '*') { //if we see a * then do the multiplication.
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
            }
            result *= factor(string, &string);
        } else if(*string == '/') { //
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
				
            }

            result /= factor(string, &string);
        } else {
            break;
        }

    }
    *lastPosition = string;
    return result;
}


long double expression(char* string, char** lastPosition)
{
    long double numResult = 0;
    long double result = 0;

    while(*string == ' ') {
        string++;    //skip spaces;
    }

    result = term(string, &string);

    while(*string != 0) {


        while(*string == ' ') {
            string++;    //skip spaces;
        }

        if(*string == '+') { //if we see a * then do the multiplication.
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
            }
            result += term(string, &string);
        } else if(*string == '-') { //
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
            }
            result -= term(string, &string);
        } else {
            break;
        }

    }
    *lastPosition = string;
    return result;
}







unsigned long int checksum(char *data,unsigned int size){
	unsigned int i;
	unsigned  long int checksum=0x00;
	
	for(i=0;i<size;i++){
		
		checksum+=data[i];
		
	}
	
	return checksum;
	
}



//char buffer[32];





void mandelbrot(){//https://youtu.be/heSGogzIEUM?t=241
/*
	int k = 15;
	int i,j,r,x,y=-16;
	while(puts(""),y++<15)
		for(x=0;x++<84;putchar(" .:-;!/>)|&IH%*#"[k&15]))
			for(i=k=r=0;j=r*r-i*i-2+x/25,i=2*r*i+y/10,j*j+i*i<11&&k++<111;r=j);
	*/
	
	int k = 0;
    float i,j,r,x,y=-16;
    char chr[] = " .:-;!/>)|&IH%*#";
	char colors[] = {41,42,43,44,45,46,47,48,49};

    puts("\n");
    while(y < 15) {
        y++;
        x = 0;
        while(x < 84) {
            x++;

            i = 0;
            r = 0;
            k = 0;

            while(1) {
                j=r*r-i*i-2+x/25;
                i=2*r*i+y/10;

                if((j*j+i*i) < 11) {
                    if(!(k < 111)) {
                        k++;
                        break;
                    }
                    k++;
                }
                else {
                    break;
                }
                r = j;
            }

            //putchar(chr[k & 15]);
			  printf("\033[1;%dm ",colors[k&15]);
        }
        puts("\n");
		
    }

}

	
	




void rtc_check(){
	
	char flags;
    char seconds;
    char minutes;
    char hours; 

	out(1,0x01);
	out(4,0x0D);
	flags=inp(7);
	if(flags&0x01){
		printf("RTC battery OK\n");
		
	}else{
		printf("RTC battery BAD\n");
	}
	printf("%x\n",flags);

    out(4,0x00);
    seconds=inp(7);
    out(4,0x02);
    minutes=inp(7);
    out(4,0x04);
    hours=inp(7);

    printf("%cx:%cx:%cx\n",hours,minutes,seconds);
    

}

void RTC_settime(int hour,int minute,int second){
	
	out(1,0x01);
	out(4,0x0E);
	out(7,0x0C);
	
	out(4,0x04);
	out(7,hour);
	
	out(4,0x02);
	out(7,minute);
	
	out(4,0x00);
	out(7,second);
	
	out(4,0x0E);
	out(7,0x04);
	
}
/*

    +-------+-----------+
    |address|type       |
    +-------+-----------+
    |0x00   |seconds    | <----> +1 for alarm reg
    |0x02   |minutes    | <----> +1 for alarm reg
    |0x04   |hours      | <----> +1 for alarm reg
    |0x06   |day        | <----> +1 for alarm reg
    |0x08   |day-of-week|
    |0x09   |months     |
    |0x0A   |year       |
    +-------+-----------+

*/


void sleepMODE(char timed,char mode){
	//,char preset removed
	//IDLES THE CPU
	while(1){
		asm(	        "	CIE ;enable interrupts from counter for now, enable outside\n"
						"	XIE ;enable external interrupts\n"
						"	REQ ;turn off Q\n");
		if(timed){
			//we set timer
			
			//asm("");
			
			switch(mode){
				
				case 0:
					asm("	STM\n"); //set timer mode and start
					break;
				case 1:
					asm("	SCM1\n");//set counter mode 1 and start
					break;
				case 2:
					asm("	SCM2\n");//set counter mode 2 and start
					break;
				case 3:
					asm("	SPM1\n");//set pulse width mode 1 and start
					break;
				case 4:
					asm("	SPM2\n");//set pulse width mode 2 and start
					break;
				case 5:
					break;
				
			}
			
			
		}
			
		asm("	ldAD R1,_INTHANDLER  ;.. R1 = INTERRUPT PC\n");//get the interrupt vector ready
		asm("	IDL\n");//pause cpu
		//-----//
		//-----//
		asm("	nop\n");
		asm("	nop\n");
		asm("	lbr _exitsleep\n");
		
		//asm("	B4 _exitsleep\n");//if B4 gets pulled low then we exit sleep mode else we loop, this is because of the watchdog of the RTC	
		
		
	}
	asm("_exitsleep:\n");
	asm("	SEQ ;turn on Q\n");
	printf("<info>::Left sleep mode (interrupt was called)\n");
    delay(1000);
    asm("   REQ\n");
}




void INT_HANDLER(){
	asm("_INTHANDLER: \n");
	asm("	SAV\n");

	
	asm("	RET\n");
	asm("	BR _INTHANDLER\n");
	//putc('>');
	
	
	
	
	
}


#include <olduino.c>
#include <stdlib.c>
#if(SCC == 0)
void includeser2()
{
    asm("BAUDRATE EQU 	9600\n");
    asm(" include xrwjrT3.inc\n");
    asm(" include serwjrT3.inc\n");
}
#endif


